"use strict";Object.defineProperty(exports,"__esModule",{value:true});const singleQuote=/'(?:[^']|'')*?(?:\\'.*|'(?!'))/;const doubleQuote=/"(?:[^"]|"")*?(?:\\".*|"(?!"))/;const dollarQuote=/(\$(?!\d)[^$]*?\$).*?(?:\1|$)/;const comment=/(?:#|--).*?(?=\r|\n|$)/;const multilineComment=/\/\*(?:[^/]|\/[^*])*?(?:\*\/|\/\*.*)/;const uuid=/[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}/;const strippedUuid=/[0-9a-f]{32}/;const hex=/0x[0-9a-f]+/;const boolean=/true|false|null/;const number=/\b-?(?:[0-9]+\.)?[0-9]+([eE][+-]?[0-9]+)?/;const oracleQuoteWithCharDelimiters=/q'(.).*\1'/gi;const oracleQuote=/q'(\[.*?\]|\{.*?\}|\(.*?\)|<.*?>)'/;function regexpToString(expressions){return expressions.toString().slice(1,-1)}class Obfuscator{constructor(replacers,flags,firstRegexp,lastRegexp){this.firstRegexp=firstRegexp;this.lastRegexp=lastRegexp;this.replacerRegexp=new RegExp(replacers.map(regexpToString).join("|"),flags)}obfuscate(statement){if(this.firstRegexp){statement=statement.replace(this.firstRegexp,"?")}statement=statement.replace(this.replacerRegexp,"?");statement=this.lastRegexp.test(statement)?"?":statement;return statement}}function obfuscate(dialect,statement){return getObfuscator(dialect).obfuscate(statement)}exports.obfuscate=obfuscate;function getObfuscator(dialect){const obf=obfuscators[dialect];if(!obf){return obfuscators[SqlDialect.MYSQL]}return obf}exports.getObfuscator=getObfuscator;var SqlDialect;(function(SqlDialect){SqlDialect["MYSQL"]="mysql";SqlDialect["POSTGRES"]="pg";SqlDialect["CASSANDRA"]="cs";SqlDialect["ORACLE"]="oracle";SqlDialect["DEFAULT"]="default"})(SqlDialect=exports.SqlDialect||(exports.SqlDialect={}));const obfuscators={};obfuscators[SqlDialect.MYSQL]=new Obfuscator([doubleQuote,singleQuote,comment,multilineComment,hex,boolean,number],"gi",null,/'|"|\/\*|\*\//);obfuscators[SqlDialect.POSTGRES]=new Obfuscator([dollarQuote,singleQuote,comment,multilineComment,uuid,strippedUuid,boolean,number],"gi",null,/'|\/\*|\*\/|(?:\$(?!\?))/);obfuscators[SqlDialect.CASSANDRA]=new Obfuscator([singleQuote,comment,multilineComment,uuid,strippedUuid,hex,boolean,number],"gi",null,/'|\/\*|\*\//);obfuscators[SqlDialect.ORACLE]=new Obfuscator([oracleQuote,singleQuote,comment,multilineComment,number],"gi",oracleQuoteWithCharDelimiters,/'|\/\*|\*\//);