"use strict";Object.defineProperty(exports,"__esModule",{value:true});const logger_1=require("../logger");const obfuscation_1=require("./obfuscation");const UNKNOWN="Other";const OPERATIONS=[["SELECT",[/^[^\S]*?select\b[\s\S]+?\bfrom[\s\n\r\[\(]+([^\]\s\n\r,)(;]*)/im,/^[^\S]*?select\b[\s\S]+.*/im]],["UPDATE",[/^[^\S]*?update[^\S]+?([^\s\n\r,;]+)/im]],["INSERT",[/^[^\S]*?insert(?:[^\S]+ignore)?[^\S]+into[^\S]+([^\s\n\r(,;]+)/im]],["DELETE",[/^[^\S]*?delete[^\S]+?from[^\S]+([^\s\n\r,(;]+)/im]]];const COMMENT_PATTERN=/\/\\*.*?\\*\//g;class ParsedStatement{constructor(obfuscatedStatement,operation,collection){this.obfuscatedStatement=obfuscatedStatement;this.operation=operation;this.collection=collection}}exports.ParsedStatement=ParsedStatement;class StatementParser{constructor(dialect){this.dialect=dialect}parse(statement){statement=(""+statement).replace(COMMENT_PATTERN,"").trim();for(const op of OPERATIONS){const opName=op[0];const regexps=op[1];for(const regexp of regexps){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`regexp=${regexp}`);if(regexp.test(statement)){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`matching ${opName} regexp: ${regexp} string: ${statement}`);const match=regexp.exec(statement);if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`match=${JSON.stringify(match)}`);const collection=(match&&match[1]?match[1]:UNKNOWN).trim();const obfuscated=obfuscation_1.obfuscate(this.dialect,statement);return new ParsedStatement(obfuscated,opName,collection)}}}return new ParsedStatement("",UNKNOWN,"")}}exports.StatementParser=StatementParser;