"use strict";Object.defineProperty(exports,"__esModule",{value:true});const logger_1=require("./logger");const os=require("os");const url=require("url");const https=require("https");const PING_URL="https://datacollector.dripstat.com/agent/v1/ping";const INIT_URL="https://datacollector.dripstat.com/agent/v1/v1/nodejs/init";const SEND_DATA_URL="https://datacollector.dripstat.com/agent/v1/v1/nodejs/data";class AppMetrics{}class AppMetricData{constructor(){this.metrics=[];this.traces=[];this.errs=[];this.sql=[]}}class AppMetricsNamedId{constructor(){this.named={};this.id={}}}class AppMetricsTransactions{constructor(){this.noParent={};this.parent=new AppMetricsNamedId;this.async=new AppMetricsNamedId}}class SendDataRequest{constructor(){this.cmdAcks=[];this.metrics=[]}}class SendDataResponseAppListData{constructor(){this.noparent=[];this.parented=[];this.async=[]}}class SendDataResponseAppList{}class DripstatServer{constructor(config,ports){this.config=config;this.ports=ports;this.isConnected=false;this.transactionNameMapping={};this.asyncTransactionSegmentNameMapping={}}auditLog(url,options,data,responseBody,resp){if(this.config.auditMode){if(resp||responseBody){logger_1.agentLogger.audit(`Received: url=${url}, headers=${resp?JSON.stringify(resp.headers):""} response=${resp?resp.statusCode:"?"}, response body:\n${responseBody}`)}else{logger_1.agentLogger.audit(`Sent: url=${url}, headers=${options?JSON.stringify(options.headers):""} request:body:\n${JSON.stringify(data)}`)}}}ping(){const that=this;this.request(PING_URL,{},null,(err,res,body)=>{that.isConnected=body=="pinged"})}initData(callback){const body={host:os.hostname(),port:this.ports?this.ports[0]:80,cpuCount:os.cpus().length,systemRam:os.totalmem()};const options={method:"POST",headers:{"X-License-Key":this.config.licenseKey,"X-App-Name":this.config.appName,"Content-Type":"application/json"}};this.request(INIT_URL,options,body,(err,res,body)=>{if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`err=${err}`);if(err){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`err=${err}`);callback(err);return}if(!res){callback(new Error(`Missing response`));return}if(res.statusCode!=200){callback(new Error(`Expected 200, got ${res.statusCode}`));return}if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`code=${res?res.statusCode:"null"} body=${body}.`);const resp=JSON.parse(body);this.appId=resp.appid;this.authToken=resp.authtoken;callback(null)})}sendMetric(transactionStats,transactionSegmentStats,callback){if(!this.authToken){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.WARNING))logger_1.agentLogger.warning(`No Authentication Token received from DripStat server yet. Retrying authentication with DripStat server`);return}const metrics=new AppMetrics;metrics.appName=this.config.appName;metrics.metricData=new AppMetricData;metrics.metricData.txns=new AppMetricsTransactions;for(const transName in transactionStats){const stat=transactionStats[transName];const name=this.transactionNameMapping[transName]?this.transactionNameMapping[transName]:transName;metrics.metricData.txns.noParent[name]=stat.toTransactionJson()}for(const transName in transactionSegmentStats){const stats=transactionSegmentStats[transName];if(stats){metrics.metricData.txns.async.named[transName]={};for(let metricName in stats){const stat=stats[metricName];metricName="Async/"+metricName;if(this.asyncTransactionSegmentNameMapping[transName]&&this.asyncTransactionSegmentNameMapping[transName][metricName]){metrics.metricData.txns.async.id[this.asyncTransactionSegmentNameMapping[transName][metricName]]=stat.toSegmentJson()}else{metrics.metricData.txns.async.named[transName][metricName]=stat.toSegmentJson()}}}}const body=new SendDataRequest;body.appMetrics=[metrics];const options={method:"POST",headers:{"Content-Type":"application/json","X-Auth-Token":this.authToken}};this.request(SEND_DATA_URL,options,body,(err,res,body)=>{if(err){callback(err);return}if(res.statusCode!=200){callback(new Error(`Expected 200, got ${res.statusCode}`));return}const resp=JSON.parse(body);if(resp.appList){for(const app of resp.appList){if(app.data&&app.data.noparent){for(const mapping of app.data.noparent){if(mapping&&mapping.name&&mapping.id){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`Added transaction name mapping ${mapping.name} -> ${mapping.id}`);this.transactionNameMapping[mapping.name]=`${mapping.id}`}}}if(app.data&&app.data.parented){}if(app.data&&app.data.async){for(const mapping of app.data.async){if(mapping&&mapping.parent&&mapping.name&&mapping.id){if(!this.asyncTransactionSegmentNameMapping[mapping.parent])this.asyncTransactionSegmentNameMapping[mapping.parent]={};if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`Added async segment name mapping ${mapping.parent}/${mapping.name} -> ${mapping.id}`);this.asyncTransactionSegmentNameMapping[mapping.parent][mapping.name]=`${mapping.id}`}}}}}})}connected(){return this.isConnected}authenticated(){return!!this.authToken&&!!this.appId}request(uri,options,body,callback){const that=this;this.auditLog(uri,options,body);const u=url.parse(uri);options.host=u.host;options.path=u.path;if(!options.method)options.method="GET";const req=https.request(options,function(res){res.setEncoding("utf8");res.on("data",function(chunk){if(res.statusCode==200){that.auditLog(uri,options,body,chunk.toString(),res);callback(null,res,chunk)}else{that.auditLog(uri,options,body,chunk?chunk.toString():null,res);callback(new Error(res.statusMessage),res,"")}if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug("Response: "+chunk)})});if(body){req.write(JSON.stringify(body))}req.end()}}exports.DripstatServer=DripstatServer;