"use strict";Object.defineProperty(exports,"__esModule",{value:true});const wrapper_1=require("../../wrapper");const logger_1=require("../../logger");const parser_1=require("../../dbstatement/parser");const obfuscation_1=require("../../dbstatement/obfuscation");const metrics_1=require("../../metrics");const utils_1=require("./utils");const __1=require("../..");const statementParser=new parser_1.StatementParser(obfuscation_1.SqlDialect.ORACLE);class CassandraInstrumentation{initialize(cassandra){const that=this;const client=require("cassandra-driver/lib/client");wrapper_1.wrapMethod(client.prototype,"cassandra exec",["execute"],function(execute){return function(){const query=arguments[0];const metric=that.metric(statementParser.parse(query));const transaction=__1.default.getExistingWebTransactionAndStartMetric(metric,metrics_1.TimerType.Async);const promise=execute.apply(this,arguments);if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`got promise for query ${query}`);wrapper_1.wrapPromise(promise,function(args){if(transaction)transaction.finishTimer(metric);if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`Promise success args=${args}`)},function(args){if(transaction)transaction.finishTimer(metric);if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.ERROR))logger_1.agentLogger.error(`Promise error args=${args}`)});return promise}});wrapper_1.wrapMethod(client.prototype,"cassandra eachRow",["eachRow"],function(eachRow){return function(){const query=arguments[0];const metric=that.metric(statementParser.parse(query));const transaction=__1.default.getExistingWebTransactionAndStartMetric(metric,metrics_1.TimerType.Async);let timerFinishedFinished=false;for(const n in arguments){if("function"==typeof arguments[n]){const callback=arguments[n];arguments[n]=function(){if(!timerFinishedFinished){if(transaction)transaction.finishTimer(metric);timerFinishedFinished=true}return callback.apply(this,arguments)}}}return eachRow.apply(this,arguments)}})}metric(statement){return utils_1.cleanMetricName(`CQL/${statement.operation}/${statement.collection}`)}}exports.CassandraInstrumentation=CassandraInstrumentation;