"use strict";Object.defineProperty(exports,"__esModule",{value:true});const logger_1=require("../../logger");const wrapper_1=require("../../wrapper");const metrics_1=require("../../metrics");const obfuscation_1=require("../../dbstatement/obfuscation");const parser_1=require("../../dbstatement/parser");const utils_1=require("./utils");const index_1=require("../../index");const statementParser=new parser_1.StatementParser(obfuscation_1.SqlDialect.MYSQL);class MysqlInstrumentation{initialize(nodule){this.wrapConnectionAndPool(nodule);if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug("initialized mysql")}wrapConnectionAndPool(nodule){const that=this;wrapper_1.wrapMethod(nodule,"mysql module",["createConnection"],function(createConnection){return function(){const conn=createConnection.apply(this,arguments);that.wrapPoolOrConn(conn);return conn}});wrapper_1.wrapMethod(nodule,"mysql module",["createPool"],function(createPool){return function(){const pool=createPool.apply(this,arguments);that.wrapPoolOrConn(pool);return pool}})}metric(statement){return utils_1.cleanMetricName(`SQL/${statement.operation}/${statement.collection}`)}wrapPoolOrConn(poolOrConn){const that=this;wrapper_1.wrapMethod(poolOrConn,"mysql pool",["query"],function(query){return function(){if(!arguments)return query.apply(this,arguments);const sql=arguments[0];let callback=arguments[arguments.length-1];if(!callback)callback=function(){};const parsed=statementParser.parse(sql);const metricName=that.metric(parsed);const transaction=index_1.default.getExistingWebTransactionAndStartMetric(metricName,metrics_1.TimerType.Async);const wrappedCallback=function(){if(transaction)transaction.finishTimer(metricName);return callback.apply(this,arguments)};arguments[arguments.length-1]=wrappedCallback;return query.apply(this,arguments)}})}}exports.MysqlInstrumentation=MysqlInstrumentation;