"use strict";Object.defineProperty(exports,"__esModule",{value:true});const config_1=require("./config");const fs=require("fs");const path=require("path");const util=require("util");var LogLevel;(function(LogLevel){LogLevel[LogLevel["ERROR"]=100]="ERROR";LogLevel[LogLevel["WARNING"]=90]="WARNING";LogLevel[LogLevel["INFO"]=80]="INFO";LogLevel[LogLevel["DEBUG"]=70]="DEBUG";LogLevel[LogLevel["AUDIT"]=1e3]="AUDIT"})(LogLevel=exports.LogLevel||(exports.LogLevel={}));const MAX_LOG_FILE_SIZE=1e9;const MAX_LOG_FILES=10;let lastLogFileCheck=Date.now();class Logger{constructor(config){this.config=config;this.minLogLevel=LogLevel.INFO;if(config.logFile){this.logFile=config.logFile}else{this.logFile=path.join(process.cwd(),"dripstat.log")}this.openStream();this.setLogLevel(config.logLevel)}error(msg,...args){this.doLog(LogLevel.ERROR,msg,args)}warning(msg,...args){this.doLog(LogLevel.WARNING,msg,args)}info(msg,...args){this.doLog(LogLevel.INFO,msg,args)}debug(msg,...args){this.doLog(LogLevel.DEBUG,msg,args)}audit(msg,...args){this.doLog(LogLevel.AUDIT,msg,args)}doLog(level,msg,args){if(this.isLevelAllowed(level)){const d=new Date;this.stream.write(util.format(`${d.getFullYear()}-${this.padWithZero(1+d.getMonth())}-${this.padWithZero(d.getDate())} ${this.padWithZero(d.getHours())}:${this.padWithZero(d.getMinutes())}:${this.padWithZero(d.getSeconds())} ${LogLevel[level]} ${msg}\n`,...args));this.checkLogFile()}}padWithZero(n){if(n<10)return"0"+n;return n}isLevelAllowed(level){return level>=this.minLogLevel||level==LogLevel.AUDIT}setLogLevel(level){if(!level){level="info"}switch(level.toLowerCase()){case"info":this.minLogLevel=LogLevel.INFO;break;case"debug":this.minLogLevel=LogLevel.DEBUG;break;case"warning":this.minLogLevel=LogLevel.WARNING;break;case"error":this.minLogLevel=LogLevel.ERROR;break;default:throw new Error(`Unknown log level ${level}`)}}checkLogFile(){if(Date.now()-lastLogFileCheck>1e3*60){lastLogFileCheck=Date.now();const stat=fs.statSync(this.logFile);if(stat.size>MAX_LOG_FILE_SIZE){for(let i=MAX_LOG_FILES;i>=0;i--){if(i==MAX_LOG_FILES){const fn=`${this.logFile}.${i}`;if(fs.existsSync(fn)){fs.unlinkSync(fn)}}else{const fn1=i==0?this.logFile:`${this.logFile}.${i}`;const fn2=`${this.logFile}.${i+1}`;if(fs.existsSync(fn1)){fs.renameSync(fn1,fn2)}}}this.openStream()}}}openStream(){this.stream=fs.createWriteStream(this.logFile,{flags:"a"});this.stream.write("----------------------------------------------------------------------------------------------------\n");this.stream.write(`Started writing log at ${new Date}`+"\n");this.stream.write("----------------------------------------------------------------------------------------------------\n");console.log(`Writing dripstat agent logs to ${this.logFile}`)}}exports.agentLogger=new Logger(config_1.AgentConfigManager.getConfig());