"use strict";Object.defineProperty(exports,"__esModule",{value:true});const metrics_1=require("./metrics");const logger_1=require("./logger");exports.TRANSACTION_TIMER="__transaction___";class Transaction{constructor(asyncId,config){this.asyncId=asyncId;this.config=config;this.timers={};this.isError=false;const timer=new metrics_1.Timer(metrics_1.TimerType.Async);this.timers[exports.TRANSACTION_TIMER]=timer.start()}getName(){if(this.overriddenName)return this.overriddenName;return this.resolveName()}setName(name){if(!name){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.WARNING))logger_1.agentLogger.warning("Empty transaction name");name="/__empty_name__"}if(!name.match(/^\/.*/)){name="/"+name}this.overriddenName=name}startTimer(metricName,type){const timer=new metrics_1.Timer(type);timer.start();this.timers[metricName]=timer}finishTimer(metricName){if(this.finished){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`Transaction already finished, ignoring timer ${metricName}`);return null}const timer=this.timers[metricName];if(!timer){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.WARNING))logger_1.agentLogger.warning("Cannot stop an unstarted timer %s",metricName);return null}timer.stop();return timer}}exports.Transaction=Transaction;class WebTransaction extends Transaction{constructor(asyncId,config){super(asyncId,config);this.frameworkPath="/*"}resolveName(){return this.method+" "+this.url}initialize(req){this.url=req.url;this.method=req.method;this.remoteAddr=req.socket?req.socket.remoteAddress:"???";this.headers=req.headers}getUrl(){return this.url}}exports.WebTransaction=WebTransaction;class ApplicationTransaction extends Transaction{constructor(asyncId,config){super(asyncId,config)}resolveName(){return""}}exports.ApplicationTransaction=ApplicationTransaction;