"use strict";Object.defineProperty(exports,"__esModule",{value:true});const logger_1=require("./logger");const async_hooks_1=require("async_hooks");const async_1=require("./async");exports.ORIGINAL_METHOD_KEY="____ORIGINAL_METHOD_KEY____";exports.WRAP_ID_KEY="____WRAP_ID_KEY____";function wrapMethod(obj,wrapId,methods,wrapper){if(!obj){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.WARNING))logger_1.agentLogger.warning("missing obj for %s",wrapId);return}if(!wrapper){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.WARNING))logger_1.agentLogger.warning("missing wrapper for %s",wrapId);return}if(!methods){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.WARNING))logger_1.agentLogger.warning("wrapping %s with no methods given",wrapId);return}methods.forEach(function(methodName){if(!obj[methodName]){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.WARNING))logger_1.agentLogger.warning("no method [%s].%s",wrapId,methodName);return}if(obj[methodName][exports.WRAP_ID_KEY]&&obj[methodName][exports.WRAP_ID_KEY]==wrapId){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.WARNING))logger_1.agentLogger.warning(`Already wrapped with ${wrapId}!!!`);return}const original=obj[methodName];obj[methodName]=wrapper(original,methodName);obj[methodName][exports.ORIGINAL_METHOD_KEY]=original;obj[methodName][exports.WRAP_ID_KEY]=wrapId;if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug("wrapped [%s].%s",wrapId,methodName)})}exports.wrapMethod=wrapMethod;function dbgWrapAll(nodule,descr){for(const el in nodule){if(typeof nodule[el]=="function"){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug("[%s] dbg wrapping %s %s",descr,descr,el);const original=nodule[el];nodule[el]=function(){let params="";for(const param of arguments){if(params)params+=", ";params+=`${typeof param}`}if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`[${descr}] calling ${el}(${params})`);const res=original.apply(this,arguments);if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`[${descr}] called ${el}(${params}), response=${typeof res}`);return res}}}}exports.dbgWrapAll=dbgWrapAll;function isWrapped(nodule,method,wrapper){if(!nodule[method]){return false}return nodule[method][exports.ORIGINAL_METHOD_KEY]!=null}exports.isWrapped=isWrapped;function wrapPromise(promise,beforeResponse,beforeError){wrapMethod(promise,"promise then",["then"],function(then){return function(){if(arguments.length==0){return then.apply(this,arguments)}if(arguments.length>=1){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`wrapping promise onResponse`);const onResponse=arguments[0];arguments[0]=function(){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`calling onResponse(${arguments})`);if(beforeResponse)beforeResponse(arguments);return onResponse.apply(this,arguments)}}if(arguments.length>=2){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`wrapping promise onError`);const onError=arguments[1];arguments[1]=function(){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`calling onError(${arguments})`);if(beforeError)beforeError(arguments);return onError.apply(this,arguments)}}return then.apply(this,arguments)}})}exports.wrapPromise=wrapPromise;class Wrapper{constructor(obj){this.obj=obj}wrapCallbacksInSyncResource(method,wrapId){wrapMethod(this.obj,wrapId,[method],function(m){return function(){const asyncResource=new async_hooks_1.AsyncResource("oracle",{triggerAsyncId:async_hooks_1.executionAsyncId(),requireManualDestroy:false});for(let i=0;i<arguments.length;i++){if("function"==typeof arguments[i]){const callback=arguments[i];arguments[i]=function(){return async_1.runInAsyncScope(asyncResource,callback,this,arguments)}}}const result=m.apply(this,arguments);wrapMethod(result,"promise then",["then"],function(then){return function(){if(arguments.length==0){return then.apply(this,arguments)}if(arguments.length>=1){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`wrapping promise onResponse`);const onResponse=arguments[0];arguments[0]=function(){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`calling onResponse(${arguments})`);return async_1.runInAsyncScope(asyncResource,onResponse,this,arguments)}}if(arguments.length>=2){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`wrapping promise onError`);const onError=arguments[1];arguments[1]=function(){if(logger_1.agentLogger.isLevelAllowed(logger_1.LogLevel.DEBUG))logger_1.agentLogger.debug(`calling onError(${arguments})`);return async_1.runInAsyncScope(asyncResource,onError,this,arguments)}}return then.apply(this,arguments)}})}})}wrapCallbackArguments(method,wrapId,wrapper){wrapMethod(this.obj,wrapId,[method],function(m){return function(){for(let i=0;i<arguments.length;i++){if("function"==typeof arguments[i]){const callback=arguments[i];arguments[i]=function(){return callback.apply(this,arguments)}}}return m.apply(this,arguments)}})}wrapPromiseResult(method){}}function wrapWithAsyncResource(obj,method,wrapId){}exports.wrapWithAsyncResource=wrapWithAsyncResource;